//Номера пинов сонара.
int Trig1;
int Echo1;

//=Режим пинов/портов ===============================
Sonar_init(int Tr, int Ec)
{
  Trig1 = Tr;
  Echo1 = Ec;
  //Задаем режимы работы пинов.
  pinMode(Trig1, OUTPUT);
  pinMode(Echo1, INPUT);
}
//=Режим пинов/портов ===============================
//= Измерение расстояния ============================
int Sonar(unsigned long Limit)
{
  int Long_cm, Long_cm_o;
  Long_cm_o = 0;
  unsigned long Lim;
  // Переводим лимит из сантиметров в относительные величины (микросек.)
  Lim = Limit * 58;

    //Генерируем импульс
    digitalWrite(Trig1, LOW);
    delayMicroseconds(2);
    digitalWrite(Trig1, HIGH);
    delayMicroseconds(10);
    digitalWrite(Trig1, LOW);
    //Ждем отражения импульса.
    // Пересчитываем время в расстояние (по скорости звуку).
    Long_cm = int(pulseIn(Echo1, HIGH, Lim) / 58);
    //Если не дождались отражения,
    // Присваиваем значение максимально измеремому.
    if (Long_cm_o < Long_cm) Long_cm_o = Long_cm;
 
  if (Long_cm_o == 0) return int(Limit);


  return Long_cm_o;
}


